﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;

namespace P20_1
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Конструктор
        public MainPage()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            //Получаем основную плитку приложения
            //Если она еще не закреплена на рабочем столе
            //будет произведена её настройка, которая повлияет на вид плитки
            //после закрепления
            ShellTile mainT = ShellTile.ActiveTiles.First();

            //Так как мы использовали шаблон FlipTile, 
            //Настроим соответствующий объект
            FlipTileData ftData = new FlipTileData();
            //Надписи на плитке
            ftData.Title = "Новая плитка!";
            ftData.Count = 1;
            ftData.BackTitle = "Добро пожаловать!";
            ftData.BackContent = "задняя часть плитки";
            ftData.WideBackContent = "задняя часть крупной плитки";
            //Передняя часть плитки
            ftData.SmallBackgroundImage = new Uri("Assets/Tiles/159x159_f.png", UriKind.Relative);
            ftData.BackgroundImage = new Uri("Assets/Tiles/336x336_f.png", UriKind.Relative);
            ftData.WideBackgroundImage = new Uri("Assets/Tiles/691x336_f.png", UriKind.Relative);
            //Задняя часть плитки
            ftData.BackBackgroundImage = new Uri("/Assets/Tiles/336x336_b.png", UriKind.Relative);
            ftData.WideBackBackgroundImage = new Uri("/Assets/Tiles/691x336_b.png", UriKind.Relative);
            //Обновим содержимое плитки
            mainT.Update(ftData);
        }

        private void btnNewTile_Click(object sender, RoutedEventArgs e)
        {

            //Список плиток
            List<ShellTile> tileList = ShellTile.ActiveTiles.ToList();

            MessageBox.Show("Количество плиток приложения: " + tileList.Count().ToString());

            //Данные циклически обновляемой плитки
            CycleTileData ctData = new CycleTileData();
            ctData.Title = "Циклическая плитка";
            ctData.Count = 2;

            //Для маленькой плитки, она не обновляется
            ctData.SmallBackgroundImage = new Uri("Assets/Tiles/159x159_c.png", UriKind.Relative);

            //Используем 2 изображения, поддерживаются до 9 изображееий
            ctData.CycleImages = new Uri[]
               {
                  new Uri("Assets/Tiles/1.jpg", UriKind.Relative), 
                  new Uri("Assets/Tiles/2.jpg", UriKind.Relative), 
                  
               };

            //Находим плитку, в строке перехода которой содержится параметр com1
            ShellTile tileFinded = ShellTile.ActiveTiles.FirstOrDefault(x => x.NavigationUri.ToString().Contains("com1"));

            if (tileFinded != null && tileFinded.NavigationUri.ToString().Contains("com1"))
            {
                //Если плитка уже есть, удаляем её, после чего создаем снова
                tileFinded.Delete();
                ShellTile.Create(new Uri("/MainPage.xaml?command=com1", UriKind.Relative), ctData, true);
            }
            else
            {
                //Если плитки нет - создаём
                ShellTile.Create(new Uri("/MainPage.xaml?command=com1", UriKind.Relative), ctData, true);
            }
        }
        //При переходе на страницу
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            IDictionary<string, string> parameters = this.NavigationContext.QueryString;
            //Анализируем переданные параметры
            if (parameters.ContainsKey("command"))
            {
                if (parameters["command"] == "com1")
                {
                    //Если пристствует параметр command со значеием com1
                    MessageBox.Show("Запуск с дополнительной плитки, с командой " + parameters["command"]);
                }
            }
            base.OnNavigatedTo(e);
        }
        //Обовление основной плитки
        private void btnStartUpdate_Click(object sender, RoutedEventArgs e)
        {
            //Объект для планирования обновления фонового изображения плитки
            //Для первой плитки - это всегда основная плитка приложения
            ShellTileSchedule tileUpdShedule = new ShellTileSchedule(ShellTile.ActiveTiles.First());
            //Интервал обновления
            tileUpdShedule.Interval = UpdateInterval.EveryHour;
            //Производить периодические обновления
            tileUpdShedule.Recurrence = UpdateRecurrence.Interval;
            //Количество периодических обновления
            tileUpdShedule.MaxUpdateCount = 24;
            //Изображениее, загружаемое при обновлении
            tileUpdShedule.RemoteImageUri = new Uri(@"http://www.weather.gov/forecasts/graphical/images/conus/MaxT1_conus.png");
            //Время запуска обновления
            tileUpdShedule.StartTime = DateTime.Now;
            //Запускаем обновления по расписанию
            tileUpdShedule.Start();
        }
    }
}